/*
 ********************************************************
	Rug Warrior Pro UMH-ISA (SITR)
 ********************************************************
	NOMBRE DEL ARCHIVO:   	comun.c
	FECHA:			
	AUTOR:   Luis M. Jimnez
	DESCRIPCIN:  
				  
	VARIABLES GLOBALES EXTERNAS:

    FUNCIONES EXTERNAS: 
		int abs(int arg);
		float fabs(float arg);
		int min(int a,int b);
		float fmin(float a,float b);
		int max(int x, int y);
		float fmax(float x, float y);
		int aprox(int val, int cmp, int tol);
		int faprox(float val, float cmp, float tol);
		int limit(int val, int low, int high);
		float flimit(float val, float low, float high);
		int strcpy(char s1[],char s2[]);
		int strcat(char s1[],char s2[]);
		void wait(int milli_seconds);
		int write_port (int port, int value, int mask);
		int random(int mod);

	VARIABLES GLOBALES USO INTERNO:

    FUNCIONES USO INTERNO: 
 ********************************************************
*/

int abs(int arg)
{  if (arg < 0)
      return -1 * arg;
    else
      return arg;
}

float fabs(float arg)
{  
	if (arg < 0.0)
      return -1.0 * arg;
    else
      return arg;
}

int min(int a,int b)
{
  if(a<b)
    return(a);
  else
    return(b);
}
float fmin(float a,float b)
{
  if(a<b)
    return(a);
  else
    return(b);
}

int max(int x, int y)
{ if (x > y)
   return x;
  else
   return y;
}

float fmax(float x, float y)
{ if (x > y)
   return x;
  else
   return y;
}


/* Determina si VAL es aproximadamente igual (con margen TOL)
  a  CMP */
int aprox(int val, int cmp, int tol)
{
  if ( (abs(val - cmp)) <= tol)
    return 1;
  else
    return 0;
 }

int faprox(float val, float cmp, float tol)
{
  if ( (fabs(val - cmp)) <= tol)
    return 1;
  else
    return 0;
 }


/* Limit a VAL to the range MIN <= LOW <= HIGH */
int limit(int val, int low, int high)
{ 
  if (val < low)
    return low;
  else if (val > high)
    return high;
  return val;
}

/* Limit a VAL to the range MIN <= LOW <= HIGH */
float flimit(float val, float low, float high)
{ 
  if (val < low)
    return low;
  else if (val > high)
    return high;
  return val;
}


int strcpy(char s1[],char s2[])
{ 
  int i;
  int l=_array_size(s1);

  for(i=0;(s2[i]!=0) && (i<l-1);i++)
    s1[i]=s2[i];
  s1[i]=0;
  return i;
}

int strcat(char s1[],char s2[])
{ 
  int i=0;
  int j=0;
  int l=_array_size(s1);

  while(s1[i]!=0) i++;

  for(j=0; (s2[j]!=0) && (i<l-1);i++,j++)
    s1[i]=s2[i];

  s1[i]=0;
  return i;
}


/* Don't busy wait, check a timer */
void wait(int milli_seconds)
{ 
	long timer_a;
	timer_a = mseconds() + (long) milli_seconds;
	while( timer_a > mseconds() )
  	{ defer(); }
}

/* Copia slamente los bits indicados en mask con el valor val en un puerto */
int write_port (int port, int value, int mask)	
{ 
	poke(port,(value & mask) | (peek(port) & ~mask));
}

/* random numbers from peeking at 2 MHZ system clock */
/* input from 2 to 32767 */
int random(int mod)
{
    return (peekword(0x100e) & 0x7fff) % mod;
}

